#ifndef MD5_H
#define MD5_H

#include <string>
#include "portable.h"

class MD5
{
public:
	MD5();
	virtual ~MD5();

	void init();
	
	void update(std::string &buf);
	void update(const  int8_t *buf, int size);
	void update(const uint8_t *buf, int size);
	
	std::string digest();
	void digest( int8_t *dst);
	void digest(uint8_t *dst);

protected:
	void process(const uint8_t *buf);
	
	uint64_t bytes;
	uint32_t work[4];
	uint8_t  buff[64];
};

#endif
